'----CONSTANTS----

Const UF_WORKSTATION_TRUST_ACCOUNT = &H1000
Const UF_ACCOUNTDISABLE = &H2
Const UF_PASSWD_NOTREQD = &H20
Const ADS_GUID_COMPUTRS_CONTAINER = "aa312825768811d1aded00c04fd8d5cd"
Const ADS_ACETYPE_ACCESS_ALLOWED = 0
Const ADS_ACEFLAG_INHERIT_ACE = 2 

'----PARAMETERS ----

lFlag = UF_WORKSTATION_TRUST_ACCOUNT Or UF_ACCOUNTDISABLE Or UF_PASSWD_NOTREQD

sComputer = InputBox("Name of new computer:")
sUserOrGroup = InputBox("Domain\username", "Who can join this computer to ads:")

'Bind again to get the correct ADsPath
sPath = "LDAP://ads.iu.edu/OU=Unclassified,OU=DSL,OU=BL-UITS,OU=BL,DC=ads,DC=iu,DC=edu"


Set compCont = GetObject(sPath)

'----CREATE A COMPUTER OBJECT----

Set comp = compCont.Create("computer", "CN=" & sComputer)
comp.Put "samAccountName", sComputer & "$"
comp.Put "userAccountControl", lFlag
comp.SetInfo

'----SET INITIAL PASSWORD----

sPwd = sComputer 
comp.SetPassword sPwd

'----SET SECURITY----

Set sd = comp.Get("ntSecurityDescriptor")
Set dacl = sd.DiscretionaryAcl

'----SET ACE----

Set ace = CreateObject("AccessControlEntry")
ace.AccessMask = -1 'Full Permission (Allowed)
ace.AceType = ADS_ACETYPE_ACCESS_ALLOWED
ace.Trustee = sUserOrGroup

'----ACL----

dacl.AddAce ace
sd.DiscretionaryAcl = dacl

'----SD----

comp.Put "ntSecurityDescriptor", Array(sd)
comp.SetInfo

'----ENABLE THE ACCOUNT----

comp.AccountDisabled = False
comp.SetInfo
