'
' Use ADO and ADSI for a better phone book search
'

ComputerName = InputBox ("Enter a Computer Name: ", "Find the Distinguished Name for:")

Set DBconnection  = CreateObject("ADODB.Connection")
Set DBcommand = CreateObject("ADODB.Command")

' Open a connection

' Use the ADSI-OLEDB Provider Name
DBconnection.Provider = "ADsDSOObject"
DBconnection.Open "Active Directory Provider"

' Create a command object for this connection
Set DBcommand.ActiveConnection = DBconnection

' Compose a search string
search_string = "select distinguishedName from 'LDAP://ads.iu.edu/DC=ads,DC=iu,DC=edu' WHERE objectCategory = 'computer' AND CN = '" & ComputerName & "'"
DBcommand.CommandText = search_string

' Execute the query
Set RecordSet = DBCommand.Execute

' Go though the record set

While Not RecordSet.EOF
	MsgBox RecordSet.Fields("distinguishedName"), 0, "The Distinguished Name number for " & ComputerName & " is:"
        RecordSet.MoveNext
Wend

MsgBox "done"




